﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel;
using System.Drawing.Design;
using Wisej.Core.Design;
using Wisej.Web;

namespace Wisej.ResponsiveNavigationPanel.NavigationPanel
{
	public class NavigationButton : UserControl
	{
		private PictureBox pictureBox;
		private Label label;

		public NavigationButton()
		{
			InitializeComponent();
		}

		[DefaultValue("navigation-button")]
		public override string AppearanceKey
		{
			get { return base.AppearanceKey; }
			set { base.AppearanceKey = value; }
		}

		[DesignerActionListAttribute]
		[Editor("Wisej.Web.Design.ImageSourceEditor, Wisej.Web.Design", typeof(UITypeEditor))]
		public string ImageSource
		{
			get { return this.pictureBox.ImageSource; }
			set { this.pictureBox.ImageSource = value; }
		}

		[Browsable(true)]
		[DesignerActionListAttribute]
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
		public override string Text
		{
			get { return this.label.Text; }
			set { this.label.Text = value; }
		}

		internal void SetDisplayMode(Display display)
		{
			switch (display)
			{
				case Display.Icon:
					this.label.Visible = false;
					break;

				default:
					this.label.Visible = true;
					break;
			}
		}

		protected override void OnClick(EventArgs e)
		{
			base.OnClick(e);

			((NavigationPanel)this.Parent).Selected = this;
		}

		private void InitializeComponent()
		{
			this.pictureBox = new Wisej.Web.PictureBox();
			this.label = new Wisej.Web.Label();
			((System.ComponentModel.ISupportInitialize)(this.pictureBox)).BeginInit();
			this.SuspendLayout();
			// 
			// pictureBox
			// 
			this.pictureBox.AppearanceKey = "navigation-button/icon";
			this.pictureBox.Enabled = false;
			this.pictureBox.Location = new System.Drawing.Point(10, 9);
			this.pictureBox.Name = "pictureBox";
			this.pictureBox.Size = new System.Drawing.Size(32, 32);
			this.pictureBox.TabIndex = 0;
			// 
			// label
			// 
			this.label.Anchor = ((Wisej.Web.AnchorStyles)(((Wisej.Web.AnchorStyles.Top | Wisej.Web.AnchorStyles.Left) 
            | Wisej.Web.AnchorStyles.Right)));
			this.label.AppearanceKey = "navigation-button/label";
			this.label.Enabled = false;
			this.label.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.label.Location = new System.Drawing.Point(52, 9);
			this.label.Name = "label";
			this.label.Size = new System.Drawing.Size(225, 32);
			this.label.TabIndex = 1;
			this.label.Text = "label1";
			this.label.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// NavigationButton
			// 
			this.AppearanceKey = "navigation-button";
			this.Controls.Add(this.label);
			this.Controls.Add(this.pictureBox);
			this.Name = "NavigationButton";
			this.Size = new System.Drawing.Size(307, 50);
			((System.ComponentModel.ISupportInitialize)(this.pictureBox)).EndInit();
			this.ResumeLayout(false);

		}
	}
}