﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel;
using System.Drawing;
using Wisej.Web;

namespace Wisej.ResponsiveNavigationPanel.NavigationPanel
{
	public class NavigationPanel : UserControl
	{
		public NavigationPanel()
		{
			InitializeComponent();
		}

		[DefaultValue("navigation-panel")]
		public override string AppearanceKey
		{
			get { return base.AppearanceKey; }
			set { base.AppearanceKey = value; }
		}

		public Display Display
		{
			get { return this._display; }
			set
			{
				if (this._display != value)
				{
					this._display = value;

					foreach (var c in this.Controls)
					{
						if (c is NavigationButton)
							((NavigationButton)c).SetDisplayMode(value);
					}

					switch (value)
					{
						case Display.Icon:
							this.pictureBoxExpand.Visible = true;
							this.pictureBoxCollapse.Visible = false;
							this.labelLogo.Visible = false;
							this._savedWidth = this.Width;
							this.Width = 52;
							break;

						default:
							this.pictureBoxExpand.Visible = false;
							this.pictureBoxCollapse.Visible = true;
							this.labelLogo.Visible = true;
							this.Width = this._savedWidth;
							break;
					}

					Update();
				}
			}
		}
		private Display _display = Display.Both;
		private int _savedWidth = 600;

		[Browsable(false)]
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public NavigationButton Selected
		{
			get { return this._selected; }
			set {
				if (this._selected != value)
				{
					if (this._selected != null)
						this._selected.BackColor = Color.Empty;

					this._selected = value;

					if (this._selected != null)
						this._selected.BackColor = Application.Theme.GetColor("selected-button");
				}
			}
		}
		private NavigationButton _selected;

		private void InitializeComponent()
		{
			this.pictureBox1 = new Wisej.Web.PictureBox();
			this.textBox1 = new Wisej.Web.TextBox();
			this.pictureBoxIcon = new Wisej.Web.PictureBox();
			this.labelLogo = new Wisej.Web.Label();
			this.pictureBoxCollapse = new Wisej.Web.PictureBox();
			this.pictureBoxExpand = new Wisej.Web.PictureBox();
			this.navigationButton4 = new Wisej.ResponsiveNavigationPanel.NavigationPanel.NavigationButton();
			this.navigationButton3 = new Wisej.ResponsiveNavigationPanel.NavigationPanel.NavigationButton();
			this.navigationButton2 = new Wisej.ResponsiveNavigationPanel.NavigationPanel.NavigationButton();
			this.navigationButton1 = new Wisej.ResponsiveNavigationPanel.NavigationPanel.NavigationButton();
			((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.pictureBoxIcon)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.pictureBoxCollapse)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.pictureBoxExpand)).BeginInit();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.ForeColor = System.Drawing.Color.White;
			this.pictureBox1.ImageSource = "resource.wx/Wisej.Ext.MaterialDesign/searching-magnifying-glass.svg";
			this.pictureBox1.Location = new System.Drawing.Point(10, 3);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(32, 32);
			this.pictureBox1.TabIndex = 1;
			// 
			// textBox1
			// 
			this.textBox1.AutoSize = false;
			this.textBox1.BackColor = System.Drawing.Color.Transparent;
			this.textBox1.BorderStyle = Wisej.Web.BorderStyle.None;
			this.textBox1.ForeColor = System.Drawing.Color.White;
			this.textBox1.Location = new System.Drawing.Point(48, 3);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(146, 32);
			this.textBox1.TabIndex = 2;
			this.textBox1.Watermark = "Search Project";
			// 
			// pictureBoxIcon
			// 
			this.pictureBoxIcon.Anchor = ((Wisej.Web.AnchorStyles)((Wisej.Web.AnchorStyles.Bottom | Wisej.Web.AnchorStyles.Left)));
			this.pictureBoxIcon.ForeColor = System.Drawing.Color.White;
			this.pictureBoxIcon.ImageSource = "resource.wx/Wisej.Ext.MaterialDesign/train-public-transport.svg?color=#FFEF00";
			this.pictureBoxIcon.Location = new System.Drawing.Point(10, 626);
			this.pictureBoxIcon.Name = "pictureBoxIcon";
			this.pictureBoxIcon.Size = new System.Drawing.Size(32, 32);
			this.pictureBoxIcon.TabIndex = 5;
			// 
			// labelLogo
			// 
			this.labelLogo.Anchor = ((Wisej.Web.AnchorStyles)(((Wisej.Web.AnchorStyles.Bottom | Wisej.Web.AnchorStyles.Left) 
            | Wisej.Web.AnchorStyles.Right)));
			this.labelLogo.Font = new System.Drawing.Font("Comic Sans MS", 16F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Pixel);
			this.labelLogo.ForeColor = System.Drawing.Color.White;
			this.labelLogo.Location = new System.Drawing.Point(48, 626);
			this.labelLogo.Name = "labelLogo";
			this.labelLogo.Size = new System.Drawing.Size(101, 32);
			this.labelLogo.TabIndex = 6;
			this.labelLogo.Text = "Wisej Rails";
			this.labelLogo.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// pictureBoxCollapse
			// 
			this.pictureBoxCollapse.Anchor = ((Wisej.Web.AnchorStyles)((Wisej.Web.AnchorStyles.Bottom | Wisej.Web.AnchorStyles.Right)));
			this.pictureBoxCollapse.Cursor = Wisej.Web.Cursors.Hand;
			this.pictureBoxCollapse.ForeColor = System.Drawing.Color.White;
			this.pictureBoxCollapse.ImageSource = "resource.wx/Wisej.Ext.MaterialDesign/left-arrow-key.svg?color=#FFFFFF";
			this.pictureBoxCollapse.Location = new System.Drawing.Point(165, 626);
			this.pictureBoxCollapse.Name = "pictureBoxCollapse";
			this.pictureBoxCollapse.Size = new System.Drawing.Size(32, 32);
			this.pictureBoxCollapse.TabIndex = 7;
			this.pictureBoxCollapse.Click += new System.EventHandler(this.pictureBoxCollapse_Click);
			// 
			// pictureBoxExpand
			// 
			this.pictureBoxExpand.Anchor = ((Wisej.Web.AnchorStyles)((Wisej.Web.AnchorStyles.Bottom | Wisej.Web.AnchorStyles.Left)));
			this.pictureBoxExpand.Cursor = Wisej.Web.Cursors.Hand;
			this.pictureBoxExpand.ForeColor = System.Drawing.Color.White;
			this.pictureBoxExpand.ImageSource = "resource.wx/Wisej.Ext.MaterialDesign/keyboard-right-arrow-button-1.svg?color=#FFF" +
    "FFF";
			this.pictureBoxExpand.Location = new System.Drawing.Point(10, 588);
			this.pictureBoxExpand.Name = "pictureBoxExpand";
			this.pictureBoxExpand.Size = new System.Drawing.Size(32, 32);
			this.pictureBoxExpand.TabIndex = 8;
			this.pictureBoxExpand.Visible = false;
			this.pictureBoxExpand.Click += new System.EventHandler(this.pictureBoxExpand_Click);
			// 
			// navigationButton4
			// 
			this.navigationButton4.Anchor = ((Wisej.Web.AnchorStyles)(((Wisej.Web.AnchorStyles.Top | Wisej.Web.AnchorStyles.Left) 
            | Wisej.Web.AnchorStyles.Right)));
			this.navigationButton4.ImageSource = "icon-folder-open";
			this.navigationButton4.Location = new System.Drawing.Point(0, 203);
			this.navigationButton4.Name = "navigationButton4";
			this.navigationButton4.Padding = new Wisej.Web.Padding(2, 0, 0, 0);
			this.navigationButton4.Size = new System.Drawing.Size(197, 50);
			this.navigationButton4.TabIndex = 4;
			this.navigationButton4.Text = "Files";
			// 
			// navigationButton3
			// 
			this.navigationButton3.Anchor = ((Wisej.Web.AnchorStyles)(((Wisej.Web.AnchorStyles.Top | Wisej.Web.AnchorStyles.Left) 
            | Wisej.Web.AnchorStyles.Right)));
			this.navigationButton3.ImageSource = "icon-calendar";
			this.navigationButton3.Location = new System.Drawing.Point(0, 149);
			this.navigationButton3.Name = "navigationButton3";
			this.navigationButton3.Padding = new Wisej.Web.Padding(2, 0, 0, 0);
			this.navigationButton3.Size = new System.Drawing.Size(197, 50);
			this.navigationButton3.TabIndex = 3;
			this.navigationButton3.Text = "Calendar";
			// 
			// navigationButton2
			// 
			this.navigationButton2.Anchor = ((Wisej.Web.AnchorStyles)(((Wisej.Web.AnchorStyles.Top | Wisej.Web.AnchorStyles.Left) 
            | Wisej.Web.AnchorStyles.Right)));
			this.navigationButton2.ImageSource = "resource.wx/Wisej.Ext.MaterialDesign/chat-bubble.svg";
			this.navigationButton2.Location = new System.Drawing.Point(0, 95);
			this.navigationButton2.Name = "navigationButton2";
			this.navigationButton2.Padding = new Wisej.Web.Padding(2, 0, 0, 0);
			this.navigationButton2.Size = new System.Drawing.Size(197, 50);
			this.navigationButton2.TabIndex = 2;
			this.navigationButton2.Text = "Discussions";
			// 
			// navigationButton1
			// 
			this.navigationButton1.Anchor = ((Wisej.Web.AnchorStyles)(((Wisej.Web.AnchorStyles.Top | Wisej.Web.AnchorStyles.Left) 
            | Wisej.Web.AnchorStyles.Right)));
			this.navigationButton1.ImageSource = "resource.wx/Wisej.Ext.MaterialDesign/tick-inside-circle.svg";
			this.navigationButton1.Location = new System.Drawing.Point(0, 41);
			this.navigationButton1.Name = "navigationButton1";
			this.navigationButton1.Padding = new Wisej.Web.Padding(2, 0, 0, 0);
			this.navigationButton1.Size = new System.Drawing.Size(197, 50);
			this.navigationButton1.TabIndex = 0;
			this.navigationButton1.Text = "Tasks";
			// 
			// NavigationPanel
			// 
			this.AppearanceKey = "navigation-panel";
			this.Controls.Add(this.pictureBoxExpand);
			this.Controls.Add(this.pictureBoxCollapse);
			this.Controls.Add(this.labelLogo);
			this.Controls.Add(this.pictureBoxIcon);
			this.Controls.Add(this.navigationButton4);
			this.Controls.Add(this.navigationButton3);
			this.Controls.Add(this.navigationButton2);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.navigationButton1);
			this.Name = "NavigationPanel";
			this.Size = new System.Drawing.Size(197, 661);
			((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.pictureBoxIcon)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.pictureBoxCollapse)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.pictureBoxExpand)).EndInit();
			this.ResumeLayout(false);

		}

		private NavigationButton navigationButton1;
		private PictureBox pictureBoxIcon;
		private Label labelLogo;
		private PictureBox pictureBoxCollapse;
		private PictureBox pictureBoxExpand;
		private System.ComponentModel.IContainer components;
		private PictureBox pictureBox1;
		private NavigationButton navigationButton2;
		private NavigationButton navigationButton3;
		private NavigationButton navigationButton4;
		private TextBox textBox1;

		private void pictureBoxExpand_Click(object sender, EventArgs e)
		{
			this.Display = Display.Both;
			this.textBox1.Visible = true;
		}

		private void pictureBoxCollapse_Click(object sender, EventArgs e)
		{
			this.Display = Display.Icon;
			this.textBox1.Visible = false;
		}
	}
}